
uniform sampler2D tex;
uniform float t;
uniform float t_scene;
uniform vec2 screen;
uniform vec4 ipos;
uniform float alpha;

#ifdef vertexcompile

smooth out vec2 coord;
layout (location=0) in vec2 pos;

void main()
{
	coord = pos;
	vec4 fpos = ipos;
	fpos.yw = -fpos.yw;
	gl_Position = vec4(pos*fpos.zw+fpos.xy*2.0-vec2(1.0,-1.0), .0, 1.0);
}
#endif

#ifdef fragmentcompile

smooth in vec2 coord;
layout (location=0) out vec4 outcol;

void main()
{
	vec4 col = texture2D(tex, coord);
	outcol = col;
	outcol.a *= alpha;
}
#endif
